#include <stdio.h>
#include "va108xx.h"
#include "reb_log.h"
#include "reb_board.h"
#include "driver_common.h"
#include "reb_timer.h"
#include "gpio_va108xx.h"




#define TIM_FUNC_01   0x1

/********************************
*
*
*
**********************************/
int CONFIG_TIM0(void)
{
	
	    VOR_GPIO->BANK[0].IRQ_ENB = 1<< 12   ;  // set PA[12] Enable bit 
	
	
			VOR_TIM0->RST_VALUE = 0x99 ; 
	    VOR_TIM0->CNT_VALUE = 0x88   ; 
	    VOR_TIM0->ENABLE = 0x88   ;  
	    VOR_TIM0->CSD_CTRL = 0x88   ;  
			VOR_TIM0->CASCADE0 = 0x99 ; 
			VOR_TIM0->CASCADE1 = 0x99 ; 
			VOR_TIM0->CASCADE2 = 0x99 ; 
	    VOR_TIM0->PWMA_VALUE = 0x88   ;  
	    VOR_TIM0->PWMB_VALUE = 0x88   ; 	
	    VOR_TIM0-> CTRL = 0x88  ;  
}	

/********************************
*  Input capture function - Uses timer to measure time a button is pressed
*   a) configure port pin as input and enable interrupt
*   b) configure TIM channel as input 
**********************************/

#define  FUNCSEL1 0x1     //  
#define T1_rollover 0xFF0010

uint32_t CONFIG_TIM1(void)
	
{
		  uint32_t temp_TIM1_CTRL[4]  ; 
	
	    temp_TIM1_CTRL[0] = 0x5500aa   ;  
	    temp_TIM1_CTRL[1] = 0x5500aa   ;  
	    temp_TIM1_CTRL[2] = 0x5500aa   ;  
	
	      VOR_GPIO->BANK[0].DATAOUT |= (1 << 9);    // set PA[9]  output to 1 
	 			VOR_GPIO->BANK[0].DIR |= (1 << 9);    // set PA[9] to an output 
	

	
			VOR_SYSCONFIG->TIM_CLK_ENABLE = 0xFF  ;  //  enable clocks to lower 16 TIM blocks 
	
// #define TIM_CAS_SRC_PORTA_2 0x2   ///  
	    VOR_TIM1->CTRL = (TIM1_CTRL_IRQ_ENB_Msk | ( 2 << TIM1_CTRL_STATUS_SEL_Pos))  ;  //  
			VOR_TIM1->RST_VALUE = T1_rollover ; 
	    VOR_TIM1->CNT_VALUE = T1_rollover ; 
	
      VOR_TIM1->CSD_CTRL |= ( TIM1_CSD_CTRL_CSDEN0_Msk ) ;
	//	    VOR_TIM1->CSD_CTRL |= ( TIM1_CSD_CTRL_CSDEN0_Msk | TIM1_CSD_CTRL_CSDINV0_Msk )     ;    // Setup cascade control so timer only counts when input is low
			VOR_TIM1->CASCADE0 = (TIM_CAS_SRC_PORTA_2) ;   // set cascade 0 source to PORTA2
			VOR_TIM1->CASCADE1 = 0x00 ; 
			VOR_TIM1->CASCADE2 = 0x00 ; 
//	    VOR_TIM1->PWMA_VALUE = 0x88   ;  
//	    VOR_TIM1->PWMB_VALUE = 0x88   ; 	
//	    VOR_TIM1-> CTRL = 0x88  ;  
			temp_TIM1_CTRL[1] = VOR_TIM1->CTRL ;   //  read CTRL register just to make sure enable = 0 
			VOR_TIM1->ENABLE = 0x1   ;    // enable TIM1
			
			temp_TIM1_CTRL[2] = VOR_TIM1->CTRL ;   //  read CTRL register just to make sure enable = 1, active should be 0  
			
			VOR_SYSCONFIG->IOCONFIG_CLKDIV1 = 0x80  ;  //  set clkdiv0 to div128
			
			VOR_IOCONFIG->PORTA[1]= IOCONFIG_PORTA_PLEVEL_Msk | IOCONFIG_PORTA_PEN_Msk |(FUNCSEL1 << IOCONFIG_PORTA_FUNSEL_Pos); // set pin func to TIM1
			VOR_IOCONFIG->PORTA[2]= ((5<<IOCONFIG_PORTA_FLTTYPE_Pos) | (1<<IOCONFIG_PORTA_FLTCLK_Pos) | IOCONFIG_PORTA_PLEVEL_Msk | IOCONFIG_PORTA_PEN_Msk );
			VOR_GPIO->BANK[0].IRQ_ENB = 1 << 2   ;  // set PA[2] Enable bit 
			VOR_GPIO->BANK[0].IRQ_SEN = 1 << 2   ; 
				VOR_GPIO->BANK[0].IRQ_EDGE = 1 << 2   ; 
		
			VOR_GPIO->BANK[0].DIR |= (1 << 1);    // set PA[1] to an output 
			VOR_GPIO->BANK[0].DIR &= ~(1 << 2);    // set PA[2] to an input 
// 			VOR_GPIO->BANK[0].DATAMASK = 1 << 10;
//			VOR_GPIO->BANK[0].DATAOUT = 0x000; 
		

	    temp_TIM1_CTRL[3] = VOR_TIM1->CTRL ;   //  read CTRL register just to make sure enable = 0 
	

 
	
	return(temp_TIM1_CTRL[3]+temp_TIM1_CTRL[2]+temp_TIM1_CTRL[1]+temp_TIM1_CTRL[0])  ;  
}	

//  ** routine to pull PA9 low  for a time dependent on the input variable  

//****************************************
//  Enable IRQ for TIM, setup IRQSEL and enable NVIC  
#define IRQ_TIM23_IRQn  30  
#define IRQ_TIM23_IRQ_PRIORITY 0  

int enable_T3_interrupt(uint32_t fred)
	
{
		     fred++  ;
	      VOR_IRQSEL->TIM[3]  = IRQ_TIM23_IRQn;   // IRQSEL redirects TIM23 to NVIC IRQ input 30 
//		    VOR_IRQSEL->TIM[23]  = 0;   // IRQSEL redirects TIM23 to NVIC IRQ input 30
				NVIC_SetPriority(IRQ_TIM23_IRQn,IRQ_TIM23_IRQ_PRIORITY);
//         NVIC_SetPriority(IRQ_TIM23_IRQn,IRQ_TIM23_IRQ_PRIORITY);
				NVIC_EnableIRQ(IRQ_TIM23_IRQn);	
	
	      VOR_TIM3->CTRL |= (TIM8_CTRL_IRQ_ENB_Msk)  ;   
	     
}

//*****************************************************
//  Interrupt Subroutine for TIM23 (NVIC IRQ30)  
//uint32_t party_time  ;

/*
void OC30_IRQHandlerX(void)  
 
{
 	uint32_t elapsed_time  ;
//	VOR_TIM23->CTRL &= ~(TIM23_CTRL_IRQ_ENB_Msk )  ;  //   disable TIM 23 INT 
    elapsed_time = 0   ;
	  elapsed_time++  ;
   VOR_TIM8->CNT_VALUE = VOR_TIM8->RST_VALUE   ; 
   party_time =  elapsed_time  ;    
}
*/

uint32_t  pulse_PA9_low(uint32_t count)
{

			uint32_t i  ; 
			i = count ;  
			VOR_GPIO->BANK[0].DATAOUT |= (1 << 9);    // set PA[9]  output to 1 
	 		VOR_GPIO->BANK[0].DIR |= (1 << 9);    // set PA[9] to an output 
	
	    VOR_GPIO->BANK[0].DATAOUT &= ~(1 << 9);    // set PA[9]  output to 0 
	    for(i=0;i<count;i++)  { VOR_GPIO->BANK[0].DATAOUT &= ~(1 << 9);  }  
	
	     VOR_GPIO->BANK[0].DATAOUT |= (1 << 9);    // set PA[9]  output to 1 
			return(0)  ;	 
}

/***************************************************************************************
 * @file     reb_main.c
 * @version  V1.0
 * @date     31. March 2016
 *
 * @note
 * VORAGO Technologies 
 *
 * @note
 * Copyright (c) 2013-2016 VORAGO Technologies. 
 *
 * @par
 * BY DOWNLOADING, INSTALLING OR USING THIS SOFTWARE, YOU AGREE TO BE BOUND BY 
 * ALL THE TERMS AND CONDITIONS OF THE VORAGO TECHNOLOGIES END USER LICENSE AGREEMENT. 
 * THIS SOFTWARE IS PROVIDED "AS IS". NO WARRANTIES, WHETHER EXPRESS, IMPLIED
 * OR STATUTORY, INCLUDING, BUT NOT LIMITED TO, IMPLIED WARRANTIES OF MERCHANTABILITY 
 * AND FITNESS FOR A PARTICULAR PURPOSE APPLY TO THIS SOFTWARE. VORAGO TECHNOLOGIES 
 * SHALL NOT, IN ANY CIRCUMSTANCES, BE LIABLE FOR SPECIAL, INCIDENTAL, OR CONSEQUENTIAL 
 * DAMAGES, FOR ANY REASON WHATSOEVER.
 *
 ****************************************************************************************/


int main()
{
	uint32_t i, pulse[16]  ;  
	VOR_TIM_SIGNAL s0, s8; 
	
	/* Enable clocks for all peripherals */ 
	VOR_SYSCONFIG->PERIPHERAL_CLK_ENABLE = ( CLK_ENABLE_PORTA | CLK_ENABLE_PORTB | CLK_ENABLE_SPIA | CLK_ENABLE_SPIB | CLK_ENABLE_SPIC |
																					 CLK_ENABLE_UARTA | CLK_ENABLE_UARTB | CLK_ENABLE_I2CA | CLK_ENABLE_I2CB | CLK_ENABLE_IRQSEL |
                                           CLK_ENABLE_IOMGR | CLK_ENABLE_UTILITY | CLK_ENABLE_PORTIO | CLK_ENABLE_SYSTEM ); 
	
//		VOR_TIM0->CASCADE0 = 0x99 ;  
	
//	i = CONFIG_TIM1()  ;  
	
	/* Initialize Logging module */ 
	VOR_Log_Init(RTT, LOG_DBG); 
	VOR_Log(LOG_INFO, ANSI_COLOR_GREEN"Welcome to Vorago Technologies REB1 VA108xx software! \n");
	if( VOR_SYSCONFIG->PROCID == PROC_ID_TORCH )
		VOR_Log(LOG_INFO, ANSI_COLOR_GREEN"VA10820 MCU ...\n");
	else
		VOR_Log(LOG_INFO, ANSI_COLOR_GREEN"VA10800 MCU ... \n");
	VOR_Log(LOG_INFO, "Restarted... \n");
	VOR_Log(LOG_INFO, "Reset Status: 0x%08x \n", VOR_SYSCONFIG->RST_STAT); 
	
	/*__________________________________________________
	 |Enable Timer|PULSE Timers| PWM PULSE | PORT PIN # |
	 |____________|____________|___________|____________|
	 | Timer 0    |  Timer 1   | Timer 7   |		PA[7]   |
	 |            |  Timer 2   | 					 |  	PA[2]	  |
	 |	   	      |	 Timer 3   | Timer 8   | 		PA[8]   |
	 | 				    |	 Timer 4   |           |		PA[4]   | 
	 |				    |	 Timer 5   | Timer 9   |  	PA[9]   |
	 |				    |	 Timer 6   |           |		PA[6]   |
	 |____________|____________|___________|____________|
	*/ 							
	VOR_TIM_Initialize(); 
	/*				
	sector		|	 0	  |	 1	  |	 2	  |  3    |  4    |  5    |
	    
						 ________________________________________________
		S0			|       |       |       |       |       |       | 
					__|       |       |       |       |       |       |
						|       |       |       |       |       |       |  
	
														 _______________ 
	  S3			|       |       |       |       |       |       | 
					__|_______|_______|				|				|_______|_______|      
						|       |       |       |       |       |       |  
	 
						|_   _  |_   _  |_   _  |_   _   _   _  |_   _  | 
		S8 			| | | | | | | | | | | | | | | | | | | | | | | | | 
					 _| |_| |_| |_| |_| |_| |_| |_| |_| |_| |_| |_| |_|_
					  |       |       |       |       |       |       |
	 
						|       |       |       |_   _  |_   _  |       |
		S8 			|       |       |       | | | | | | | | |       | 
					__|_______|_______|_______| |_| |_| |_| |_|_______|_
						|       |       |       |       |       |       |
   */	
	s8.trig = (VOR_TIM_TRIGSIGNAL){.timer_instance = 0, .port_num = 0, .pin_num = 0, .cycle = 18000}; 
	s8.pulse = (VOR_TIM_PULSESIGNAL){.timer_instance = 3, .port_num = 0, .pin_num = 3, .cycle = 18000, .start_offset = 9000, .end_offset = 15000, .inverse = false}; 
	s8.pwmpulse = (VOR_TIM_PWMPULSESIGNAL){.timer_instance = 8, .port_num = 0, .pin_num = 8, .cycle = 50}; 
	s8.type = SIGNAL_TYPE_PWMPULSE; 
	VOR_TIM_Create(s8); 	


     enable_T3_interrupt(10)  ;  	
		
	s0.trig = (VOR_TIM_TRIGSIGNAL){.cycle = 18000, .pin_num = 0, .port_num = 0, .timer_instance = 0}; 
	s0.type = SIGNAL_TYPE_TRIGGER; 	 
	
	
	VOR_TIM_Create(s0); 
	
	VOR_TIM_Enable(); 
	
	for(i=0;i<16;i++)  { pulse[i]= 0x00  ;  }    // clear the pulse array  
	 
	i = pulse_PA9_low(100)  ;   

	  
	while(1) 
	{
			if((VOR_GPIO->BANK[0].DATAIN & (1<<2)) !=0)    //  if the port pin is high, check the timer for a non-reset value
			{
 				if(VOR_TIM1->CNT_VALUE <= (T1_rollover-50) ) 
				{
					pulse[i++] = T1_rollover - VOR_TIM1->CNT_VALUE  ; 
					VOR_TIM1->CNT_VALUE = T1_rollover  ;  
					if(i==16)  {  i = 0 ;  } 
				}
			}	
	   pulse_PA9_low(1000)  ;  
	}
}
