#include <stdio.h>
#include "va108xx.h"
#include "reb_log.h"
#include "reb_board.h"
#include "driver_common.h"
#include "reb_timer.h"
#include "gpio_va108xx.h"




#define TIM_FUNC_01   0x1

/********************************
*
*
*
**********************************/
int CONFIG_TIM0(void)
{
	
	    VOR_GPIO->BANK[0].IRQ_ENB = 1<< 12   ;  // set PA[12] Enable bit 
	
	
			VOR_TIM0->RST_VALUE = 0x99 ; 
	    VOR_TIM0->CNT_VALUE = 0x88   ; 
	    VOR_TIM0->ENABLE = 0x88   ;  
	    VOR_TIM0->CSD_CTRL = 0x88   ;  
			VOR_TIM0->CASCADE0 = 0x99 ; 
			VOR_TIM0->CASCADE1 = 0x99 ; 
			VOR_TIM0->CASCADE2 = 0x99 ; 
	    VOR_TIM0->PWMA_VALUE = 0x88   ;  
	    VOR_TIM0->PWMB_VALUE = 0x88   ; 	
	    VOR_TIM0-> CTRL = 0x88  ; 
       return(0)  ;  	
}	

/********************************
*  Input capture function - Uses timer to measure time a button is pressed
*   a) configure port pin as input and enable interrupt
*   b) configure TIM channel as input 
**********************************/

#define  FUNCSEL1 0x1     //  
#define PWM_period 2500
#define STAT_SEL_1CYC  0 
#define STAT_SEL_ACTIVE 1
#define STAT_SEL_TOGGLE 2
#define STAT_SEL_PWMA 3
#define STAT_SEL_PWMB 4 
#define STAT_SEL_ENAB  5
#define STAT_SEL_PWM_ACTIVE 6 


//*************************************************************************
//  Routine to configure TIM2 as PWMB mode 
//    
//**************************************************************************
uint32_t CONFIG_TIM1_PWMA(void)
{
	    VOR_SYSCONFIG->PERIPHERAL_CLK_ENABLE = 0xFFFFFFFF  ;  //  enable all peripheral clocks 
			VOR_SYSCONFIG->TIM_CLK_ENABLE = 0xFF  ;  //  enable clocks to lower 16 TIM blocks 
	
			VOR_IOCONFIG->PORTA[1]= IOCONFIG_PORTA_PLEVEL_Msk | IOCONFIG_PORTA_PEN_Msk |(FUNCSEL1 << IOCONFIG_PORTA_FUNSEL_Pos); // set pin func to TIM1
		
			VOR_GPIO->BANK[0].DIR |= (1 << 1);    // set PA[1] to an output 

	
// #define TIM_CAS_SRC_PORTA_2 0x2   ///  
	    VOR_TIM1->CTRL = (TIM1_CTRL_IRQ_ENB_Msk | ( STAT_SEL_PWMA << TIM1_CTRL_STATUS_SEL_Pos))  ;  //  
			VOR_TIM1->RST_VALUE = PWM_period ; 
	    VOR_TIM1->CNT_VALUE = PWM_period ; 
	
 //     VOR_TIM1->CSD_CTRL |= ( TIM1_CSD_CTRL_CSDEN0_Msk ) ;
	//	    VOR_TIM1->CSD_CTRL |= ( TIM1_CSD_CTRL_CSDEN0_Msk | TIM1_CSD_CTRL_CSDINV0_Msk )     ;    // Setup cascade control so timer only counts when input is low
//			VOR_TIM1->CASCADE0 = (TIM_CAS_SRC_PORTA_2) ;   // set cascade 0 source to PORTA2
//			VOR_TIM1->CASCADE1 = 0x00 ; 
//			VOR_TIM1->CASCADE2 = 0x00 ; 
      VOR_TIM1->PWMA_VALUE = 500   ;  
//	    VOR_TIM1->PWMB_VALUE = 0x88   ; 	
//	    VOR_TIM1-> CTRL = 0x88  ;  

			VOR_TIM1->ENABLE = 0x1   ;    // enable TIM1
			 return(0)  ;  	
}
	

//*************************************************************************
//  Routine to configure TIM2 as PWMB mode 
//    
//**************************************************************************
uint32_t CONFIG_TIM2_PWMB(void)
{
	    VOR_SYSCONFIG->PERIPHERAL_CLK_ENABLE = 0xFFFFFFFF  ;  //  enable all peripheral clocks 
			VOR_SYSCONFIG->TIM_CLK_ENABLE = 0xFF  ;  //  enable clocks to lower 16 TIM blocks 
	
			VOR_IOCONFIG->PORTA[2]= IOCONFIG_PORTA_PLEVEL_Msk | IOCONFIG_PORTA_PEN_Msk |(FUNCSEL1 << IOCONFIG_PORTA_FUNSEL_Pos); // set pin func to TIM1
		
			VOR_GPIO->BANK[0].DIR |= (2 << 1);    // set PA[1] to an output 

#define TIM_CAS_SRC_PORTA_11 11   // 
	    VOR_TIM2->CTRL = (TIM1_CTRL_IRQ_ENB_Msk | ( STAT_SEL_PWMB << TIM1_CTRL_STATUS_SEL_Pos))  ;  //  
			VOR_TIM2->RST_VALUE = PWM_period ; 
	    VOR_TIM2->CNT_VALUE = PWM_period ; 
	
		  VOR_TIM2->CSD_CTRL |= ( TIM1_CSD_CTRL_CSDEN0_Msk  | TIM1_CSD_CTRL_CSDTRG0_Msk ) ;  
												// Setup cascade control so timer triggers when PA11(button) is pressed
			VOR_TIM2->CASCADE0 = (TIM_CAS_SRC_PORTA_11) ;   // set cascade 0 source to PORTA11
			VOR_TIM2->CASCADE1 = 0x00 ; 
			VOR_TIM2->CASCADE2 = 0x00 ; 
      VOR_TIM2->PWMA_VALUE = PWM_period * .9   ;  
	    VOR_TIM2->PWMB_VALUE = PWM_period * .1	; 	
 
			VOR_TIM2->ENABLE = 0x1   ;    // enable TIM1
			
	return(PWM_period)  ;  
}	
//*************************************************************************
//  Routine to configure TIM3 as PWMB mode 
//    
//**************************************************************************
uint32_t CONFIG_TIM3_PWMB(void)
{
	    VOR_SYSCONFIG->PERIPHERAL_CLK_ENABLE = 0xFFFFFFFF  ;  //  enable all peripheral clocks 
			VOR_SYSCONFIG->TIM_CLK_ENABLE = 0xFFFF  ;  //  enable clocks to lower 16 TIM blocks 
	
			VOR_IOCONFIG->PORTA[3]= IOCONFIG_PORTA_PLEVEL_Msk | IOCONFIG_PORTA_PEN_Msk |(FUNCSEL1 << IOCONFIG_PORTA_FUNSEL_Pos); // set pin func to TIM1
		
			VOR_GPIO->BANK[0].DIR |= (3 << 1);    // set PA[3] to an output 

#define TIM_CAS_SRC_PORTA_11 11   ///  
	    VOR_TIM3->CTRL = (TIM1_CTRL_IRQ_ENB_Msk | ( STAT_SEL_PWMB << TIM1_CTRL_STATUS_SEL_Pos))  ;  //  
			VOR_TIM3->RST_VALUE = PWM_period ; 
	    VOR_TIM3->CNT_VALUE = PWM_period ; 
	
 	    VOR_TIM3->CTRL = (TIM1_CTRL_IRQ_ENB_Msk | ( STAT_SEL_PWMB << TIM1_CTRL_STATUS_SEL_Pos))  ;  //  
			VOR_TIM3->RST_VALUE = PWM_period ; 
	    VOR_TIM3->CNT_VALUE = PWM_period ; 
	
		  VOR_TIM3->CSD_CTRL |= ( TIM1_CSD_CTRL_CSDEN0_Msk | TIM1_CSD_CTRL_CSDTRG0_Msk ) ;  
												// Setup cascade control so timer triggers when PA11(button) is pressed
			VOR_TIM3->CASCADE0 = (TIM_CAS_SRC_PORTA_11) ;   // set cascade 0 source to PORTA11
			VOR_TIM3->CASCADE1 = 0x00 ; 
			VOR_TIM3->CASCADE2 = 0x00 ; 
      VOR_TIM3->PWMA_VALUE = PWM_period * .6   ;  
	    VOR_TIM3->PWMB_VALUE = PWM_period * .4  ; 	
//	    VOR_TIM1-> CTRL = 0x88  ;  

			VOR_TIM3->ENABLE = 0x1   ;    // enable TIM3
			
	return(PWM_period)  ;  
}	

#define IRQ_TIM1_PRIORITY  0
#define IRQ_TIM1_INDEX     1
#define IRQ_TIM1_IRQn     OC1_IRQn


//*************************************************************************
//  Routine to configure TIM23 as 10 msec TICK generator  
//      - includes IRQSEL and NVIC configuration 
//      - IRQ30 services TIM23  (10 msec Tick) 
//**************************************************************************
#define IRQ_TIM23_IRQn     OC30_IRQn  
#define IRQ_TIM23_IRQ_PRIORITY  0  

uint32_t CONFIG_TIM23_periodic_int(void)
{
		  VOR_TIM23->CTRL = (TIM23_CTRL_IRQ_ENB_Msk | ( STAT_SEL_1CYC << TIM1_CTRL_STATUS_SEL_Pos))  ;  //  
			VOR_TIM23->RST_VALUE = (10e-3 * 50e6) ;   // setup RST value for 10 msec  
	    VOR_TIM23->CNT_VALUE = (10e-3 * 50e6) ; 
	
//		  VOR_TIM23->CSD_CTRL |= NA ;  
												// Setup cascade control so timer triggers when PA11(button) is pressed
//			VOR_TIM23->CASCADE0 = NA ;   
//			VOR_TIM23->CASCADE1 = NA ; 
//			VOR_TIM23->CASCADE2 = NA ; 
//      VOR_TIM23->PWMA_VALUE = NA   ;  
//	    VOR_TIM23->PWMB_VALUE = NA  ; 	
      VOR_TIM23->ENABLE = 0x1   ;    // enable TIM23
	
	    VOR_IRQSEL->TIM[23]  = IRQ_TIM23_IRQn;   // IRQSEL redirects TIM23 to NVIC IRQ input 30 

			NVIC_SetPriority(IRQ_TIM23_IRQn,IRQ_TIM23_IRQ_PRIORITY);  // set priority in NVIC for IRQ30
			NVIC_EnableIRQ(IRQ_TIM23_IRQn);	  //  enable NVIC IRQ30 
			
			SysTick->CTRL  = SysTick_CTRL_CLKSOURCE_Msk |
      SysTick_CTRL_TICKINT_Msk   |
      SysTick_CTRL_ENABLE_Msk;   
			
			VOR_IOCONFIG->PORTA[5] |= IOCONFIG_PORTA_IEWO_Msk   ; 
			VOR_IOCONFIG->PORTA[6] |= IOCONFIG_PORTA_IEWO_Msk   ;
			VOR_GPIO->BANK[0].DIR |= (1 << 6);    // set PA[6] to an output.  this is LED4 on REB1 board, toggle every 1 sec   
			VOR_GPIO->BANK[0].DIR |= (1 << 5);    // set PA[5] to an output.  this is available I/O on REB1, toggle every 1 sec
			VOR_GPIO->BANK[0].DIR |= (1 << 4);   //  set PA[4] to an output.  This will Toggle every 10 msec 
			
				 return (0)   ;  

}

//  *****  Global variables defined here  ******  
     uint32_t  cnt_10ms, cnt_sec ; //  global variable for keeping track of 10 msec  
     uint32_t  old_SYSTICK    ;    //  global variable for checking TIM derived 10 msec 
     uint32_t  new_SYSTICK    ;    //  global variable for checking TIM derived 10 msec
     uint32_t  elapsed_time_array[16], i ; // global variable for checking TIM derived 10 msec
//*****************************************************
//  Interrupt Subroutine for TIM23 (NVIC IRQ30)  
//******************************************************
void OC30_IRQHandlerX(void)   
{
 	uint32_t elapsed_time  ;

	 	  VOR_GPIO->BANK[0].TOGOUT = (1 << 4); //  toggle PA4 every 10 msec 

		if(cnt_10ms++ >= 99)
	{
			cnt_sec ++  ;  
			VOR_GPIO->BANK[0].DATAOUT ^= ((1 << 5)|(1<<6)) ;   // toggle PA5 and PA6
			cnt_10ms = 0 ;  
  	}
	
			new_SYSTICK = SysTick->VAL  ;    //   Use Cortex-M0 systick to check TIM accuracy
			elapsed_time = ((old_SYSTICK - new_SYSTICK) & 0xFFFFFF)   ;  // systick only has 24 bits, need to ignore top 8 bits
			old_SYSTICK = new_SYSTICK  ;  

			if(i>16)  i = 0  ;  //  keeping rolling array of elapsed time intervals 
			elapsed_time_array[i++] = elapsed_time  ;    //   store elapse tick count for the last 16 interrupts 
}

//*****************************************************
//  Routine to configure the push button switch as an edge sensitive interrupt
//    -   pullup enable, digital filter set for div32 clock * 5 samples  = 
//    -    interrupt only on falling edge. 

#define user_button_pin  11 

uint32_t setup_pushbutton(uint32_t debounce_count)
{
			VOR_SYSCONFIG->IOCONFIG_CLKDIV1 = 0x20  ;  //  set clkdiv0 to div32
			
			VOR_IOCONFIG->PORTA[11]= (IOCONFIG_PORTA_PLEVEL_Msk | IOCONFIG_PORTA_PEN_Msk); // 
//			VOR_IOCONFIG->PORTA[11]= ((debounce_count<<IOCONFIG_PORTA_FLTTYPE_Pos) | (1<<IOCONFIG_PORTA_FLTCLK_Pos) | IOCONFIG_PORTA_PLEVEL_Msk | IOCONFIG_PORTA_PEN_Msk );
		  	VOR_IOCONFIG->PORTA[11]= ((5<<IOCONFIG_PORTA_FLTTYPE_Pos) | (1<<IOCONFIG_PORTA_FLTCLK_Pos) | IOCONFIG_PORTA_PLEVEL_Msk | IOCONFIG_PORTA_PEN_Msk );
		
      VOR_GPIO->BANK[0].DIR &= !(1 << user_button_pin)  ;  //  set PA11 as input
	    VOR_GPIO->BANK[0].IRQ_EVT &= ~(1 << user_button_pin)   ; //  set to zero for interrupt on H->L transition 
			VOR_GPIO->BANK[0].IRQ_SEN &= ~(1 << user_button_pin)   ; //  set to zero for interrupt on sig transition
			VOR_GPIO->BANK[0].IRQ_EDGE |= 1 << user_button_pin     ;  //  set to 1 
//	    VOR_GPIO->BANK[0].IRQ_ENB |= 1 << user_button_pin      ;  // set PA[11] Enable bit 
	 return (0)   ;  

}

//****************************************
//  Enable IRQ for TIM, setup IRQSEL and enable NVIC  


int enable_T3_interrupt(uint32_t fred)
	
{
		     fred++  ;
	      VOR_IRQSEL->TIM[3]  = IRQ_TIM23_IRQn;   // IRQSEL redirects TIM23 to NVIC IRQ input 30 
//		    VOR_IRQSEL->TIM[23]  = 0;   // IRQSEL redirects TIM23 to NVIC IRQ input 30
				NVIC_SetPriority(IRQ_TIM23_IRQn,IRQ_TIM23_IRQ_PRIORITY);
//         NVIC_SetPriority(IRQ_TIM23_IRQn,IRQ_TIM23_IRQ_PRIORITY);
				NVIC_EnableIRQ(IRQ_TIM23_IRQn);	
	
	      VOR_TIM3->CTRL |= (TIM8_CTRL_IRQ_ENB_Msk)  ;   
	      return(0)   ; 
}
uint32_t  cnt_SysTick   ;    //  global variable 
int SysTick_Handler () 
{
		cnt_SysTick  ++  ;
		SysTick->CTRL  = SysTick_CTRL_CLKSOURCE_Msk |
                   SysTick_CTRL_TICKINT_Msk   |
                   SysTick_CTRL_ENABLE_Msk;    
	  SysTick->VAL = 0xFFFFFF   ;  
	  SysTick->LOAD = 0xFFFFFF   ;  
	  return(0)   ;  
}  
//*****************************************************
//  ** routine to pull PA9 low  for a time dependent on the input variable  

uint32_t  pulse_PA9_low(uint32_t count)
{

			uint32_t i  ; 
			i = count ;  
			VOR_GPIO->BANK[0].DATAOUT |= (1 << 9);    // set PA[9]  output to 1 
	 		VOR_GPIO->BANK[0].DIR |= (1 << 9);    // set PA[9] to an output 
	
	    VOR_GPIO->BANK[0].DATAOUT &= ~(1 << 9);    // set PA[9]  output to 0 
	    for(i=0;i<count;i++)  { VOR_GPIO->BANK[0].DATAOUT &= ~(1 << 9);  }  
	
	     VOR_GPIO->BANK[0].DATAOUT |= (1 << 9);    // set PA[9]  output to 1 
			return(0)  ;	 
}

/***************************************************************************************
 * @file     reb_main.c
 * @version  V1.0
 * @date     31. March 2016
 *
 * @note
 * VORAGO Technologies 
 *
 * @note
 * Copyright (c) 2013-2016 VORAGO Technologies. 
 *
 * @par
 * BY DOWNLOADING, INSTALLING OR USING THIS SOFTWARE, YOU AGREE TO BE BOUND BY 
 * ALL THE TERMS AND CONDITIONS OF THE VORAGO TECHNOLOGIES END USER LICENSE AGREEMENT. 
 * THIS SOFTWARE IS PROVIDED "AS IS". NO WARRANTIES, WHETHER EXPRESS, IMPLIED
 * OR STATUTORY, INCLUDING, BUT NOT LIMITED TO, IMPLIED WARRANTIES OF MERCHANTABILITY 
 * AND FITNESS FOR A PARTICULAR PURPOSE APPLY TO THIS SOFTWARE. VORAGO TECHNOLOGIES 
 * SHALL NOT, IN ANY CIRCUMSTANCES, BE LIABLE FOR SPECIAL, INCIDENTAL, OR CONSEQUENTIAL 
 * DAMAGES, FOR ANY REASON WHATSOEVER.
 *
 ****************************************************************************************/


int main()
{
//	uint32_t i, pulse[16]  ;  
	VOR_TIM_SIGNAL s0, s8; 
	
	/* Enable clocks for all peripherals */ 
	VOR_SYSCONFIG->PERIPHERAL_CLK_ENABLE = ( CLK_ENABLE_PORTA | CLK_ENABLE_PORTB | CLK_ENABLE_SPIA | CLK_ENABLE_SPIB | CLK_ENABLE_SPIC |
																					 CLK_ENABLE_UARTA | CLK_ENABLE_UARTB | CLK_ENABLE_I2CA | CLK_ENABLE_I2CB | CLK_ENABLE_IRQSEL |
                                           CLK_ENABLE_IOMGR | CLK_ENABLE_UTILITY | CLK_ENABLE_PORTIO | CLK_ENABLE_SYSTEM ); 
	
	
		setup_pushbutton(50)  ;     //   setup PA11 (push button on REB1) to generate an interrupt when pressed 
	
	i = CONFIG_TIM1_PWMA()  ;  

	i = CONFIG_TIM2_PWMB()   ;  
	i = CONFIG_TIM3_PWMB()   ; 
	
	VOR_SYSCONFIG->TIM_CLK_ENABLE |= 1<<23   ;  //  enable TIM23 clock 
	 i =  CONFIG_TIM23_periodic_int()   ;  
	
   

	VOR_GPIO->BANK[0].IRQ_ENB |= 1 << user_button_pin    ; 	
	
		while(1) 
	{
  
	}
	

	
	/* Initialize Logging module */ 
	VOR_Log_Init(RTT, LOG_DBG); 
	VOR_Log(LOG_INFO, ANSI_COLOR_GREEN"Welcome to Vorago Technologies REB1 VA108xx software! \n");
	if( VOR_SYSCONFIG->PROCID == PROC_ID_TORCH )
		VOR_Log(LOG_INFO, ANSI_COLOR_GREEN"VA10820 MCU ...\n");
	else
		VOR_Log(LOG_INFO, ANSI_COLOR_GREEN"VA10800 MCU ... \n");
	VOR_Log(LOG_INFO, "Restarted... \n");
	VOR_Log(LOG_INFO, "Reset Status: 0x%08x \n", VOR_SYSCONFIG->RST_STAT); 
	
	/*__________________________________________________
	 |Enable Timer|PULSE Timers| PWM PULSE | PORT PIN # |
	 |____________|____________|___________|____________|
	 | Timer 0    |  Timer 1   | Timer 7   |		PA[7]   |
	 |            |  Timer 2   | 					 |  	PA[2]	  |
	 |	   	      |	 Timer 3   | Timer 8   | 		PA[8]   |
	 | 				    |	 Timer 4   |           |		PA[4]   | 
	 |				    |	 Timer 5   | Timer 9   |  	PA[9]   |
	 |				    |	 Timer 6   |           |		PA[6]   |
	 |____________|____________|___________|____________|
	*/ 							
	VOR_TIM_Initialize(); 
	/*				
	sector		|	 0	  |	 1	  |	 2	  |  3    |  4    |  5    |
	    
						 ________________________________________________
		S0			|       |       |       |       |       |       | 
					__|       |       |       |       |       |       |
						|       |       |       |       |       |       |  
	
														 _______________ 
	  S3			|       |       |       |       |       |       | 
					__|_______|_______|				|				|_______|_______|      
						|       |       |       |       |       |       |  
	 
						|_   _  |_   _  |_   _  |_   _   _   _  |_   _  | 
		S8 			| | | | | | | | | | | | | | | | | | | | | | | | | 
					 _| |_| |_| |_| |_| |_| |_| |_| |_| |_| |_| |_| |_|_
					  |       |       |       |       |       |       |
	 
						|       |       |       |_   _  |_   _  |       |
		S8 			|       |       |       | | | | | | | | |       | 
					__|_______|_______|_______| |_| |_| |_| |_|_______|_
						|       |       |       |       |       |       |
   */	
	s8.trig = (VOR_TIM_TRIGSIGNAL){.timer_instance = 0, .port_num = 0, .pin_num = 0, .cycle = 18000}; 
	s8.pulse = (VOR_TIM_PULSESIGNAL){.timer_instance = 3, .port_num = 0, .pin_num = 3, .cycle = 18000, .start_offset = 9000, .end_offset = 15000, .inverse = false}; 
	s8.pwmpulse = (VOR_TIM_PWMPULSESIGNAL){.timer_instance = 8, .port_num = 0, .pin_num = 8, .cycle = 50}; 
	s8.type = SIGNAL_TYPE_PWMPULSE; 
	VOR_TIM_Create(s8); 		
	// enable_T3_interrupt(10) ;  //   ***  added by Clay  		
	s0.trig = (VOR_TIM_TRIGSIGNAL){.cycle = 18000, .pin_num = 0, .port_num = 0, .timer_instance = 0}; 
	s0.type = SIGNAL_TYPE_TRIGGER; 	 
	VOR_TIM_Create(s0); 
	
	VOR_TIM_Enable(); 
	

	 
	i = pulse_PA9_low(100)  ;   

	  
	while(1) 
	{
			   pulse_PA9_low(1000)  ;  
	}
}
